;******************************************************************************
;  *   	@MCU   	   	   	   	 : MC30P6250
;  *   	@Create Date         : 2020.01.09
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@֧QQȺ   	  : 814641858      
;  *    @΢ٷ̳   	  : http://bbs.sinomcu.com/	 
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------    	
;  *           	   	   	 TIMER0    	   	P14 1msת
;      	   	   	   	   	   	TIMER1 PWM 	
;      	   	   	   	   	   	   	   	   	P12  T=80K, D=20% 
;      	   	   	   	   	   	   	   	   	P11	 T=80K, D=40% 
;      	   	   	   	   	   	   	   	   	P10  T=80K, D=60% 
;      	   	   	   	   	   	   	   	   	P15  T=80K, D=80% 
;******************************************************************************
#include "MC30P6250.INC"

cblock 0x0010
abuf
statusbuf
endc

   	ORG     0x0000
   	goto   	MAIN
    ORG     0x8
   	goto   	INT_ISR	   	;ж

 
INT_ISR:

   	movra   abuf
   	swapar  STATUS
   	movra   statusbuf
   	

   	JBSET  	T0IF
   	GOTO   	T0_END 
   	JBSET  	T0IE
   	GOTO   	T0_END
   	BCLR   	T0IF
   	MOVAI  	130
   	MOVRA  	T0CNT
    MOVAI   00010000B
    XORRA   P1              ;P14ת
T0_END:

   	JBSET  	T1IF
   	GOTO   	T1_END
   	JBSET  	T1IE
   	GOTO   	T1_END
   	BCLR   	T1IF
T1_END:

   	JBSET  	CMPIE
   	GOTO   	CMP_END
   	JBSET  	CMPIF
   	GOTO   	CMP_END
   	BCLR   	CMPIF
CMP_END:

   	swapar  statusbuf
   	movra   STATUS
   	swapr   abuf
   	swapar  abuf
   	
END_OF_INTERRUPT
   	RETIE  	


MAIN:

   	CALL   	SYS_INIT
WHILE_LOOP:
   	GOTO   	WHILE_LOOP
   	RETURN 	
; exit point of MAIN


SYS_INIT:

   	BCLR   	GIE
   	CALL   	C_RAM
   	CALL   	IO_INIT
   	CALL   	TIMER0_INT_INIT
   	CALL   	TIMER1_PWM_INIT
   	BSET   	GIE
   	RETURN 	
; exit point of SYS_INIT


TIMER1_PWM_INIT:

   	MOVAI  	0x63
   	MOVRA  	PWM1CR0
   	MOVAI  	0x03        
   	MOVRA  	PWM1CR1                ;ȡ
   	MOVAI  	99
   	MOVRA  	T1LOAD
   	MOVAI  	99
   	MOVRA   T1CNT
   	MOVAI  	20
   	MOVRA  	T1DATA
   	MOVAI  	40
   	MOVRA  	T1DATB
   	MOVAI  	60
   	MOVRA  	T1DATC
   	MOVAI  	80
   	MOVRA  	T1DATD
   	MOVAI  	0xc0
   	MOVRA  	T1CR                    ;Fcpu 1Ƶ
   	RETURN 	
; exit point of TIMER1_PWM_INIT


TIMER0_INT_INIT:

   	MOVAI  	0x05
   	MOVRA  	T0CR                   ;ʱΪCPUʱ    ʱ64Ƶ  1ms
   	MOVAI  	130
   	MOVRA  	T0CNT
   	BSET   	T0IE
   	RETURN 	
; exit point of TIMER0_INT_INIT


IO_INIT:

   	CLRR   	P1                      ;1:input 0:output
   	CLRR   	DDR1                    ;1:input 0:output 
   	MOVAI  	0xff
   	MOVRA  	PUCON                   ;0:Effective 1:invalid
   	MOVRA  	PDCON                   ;0:Effective 1:invalid
   	CLRR   	ODCON                   ;0:  1:©
   	RETURN 	
; exit point of IO_INIT


C_RAM:
   	movai 0x40
   	movra FSR
   	movai 48
   	movra 0x07
   	decr FSR
   	clrr INDF
   	djzr 0x07
   	goto $ -3;
   	clrr 0x07
   	
   	RETURN 	
; exit point of C_RAM


   	end


